--- 1/res/res_pjsip_nat.c	2020-11-12 15:02:07.530732085 +0100
+++ 2/res/res_pjsip_nat.c	2020-12-08 11:51:34.579962905 +0100
@@ -73,7 +73,7 @@
 		save_orig_contact_host(rdata, uri);
 	}
 
-	pj_cstr(&uri->host, rdata->pkt_info.src_name);
+	pj_strdup2(rdata->tp_info.pool, &uri->host, rdata->pkt_info.src_name);
 	uri->port = rdata->pkt_info.src_port;
 	if (!strcasecmp("WSS", rdata->tp_info.transport->type_name)) {
 		/* WSS is special, we don't want to overwrite the URI at all as it needs to be ws */
@@ -129,9 +129,7 @@
 				break;
 			}
 		}
-	} else if (pjsip_method_cmp(&rdata->msg_info.msg->line.req.method, &pjsip_register_method)) {
-		rr = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_RECORD_ROUTE, NULL);
-	} else {
+	} else if (!pjsip_method_cmp(&rdata->msg_info.msg->line.req.method, &pjsip_register_method)) {
 		/**
 		 * Record-Route header has no meaning in REGISTER requests
 		 * and should be ignored
@@ -147,6 +145,9 @@
 		 * hope for the best
 		 */
 		pubsub = 1;
+		if (rdata->msg_info.msg->type != PJSIP_RESPONSE_MSG) {
+			rr = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_RECORD_ROUTE, NULL);
+		}
 	}
 
 	if (rr) {
